package com.sosnoski.person;

import java.util.*;

import javax.xml.rpc.Stub;

public class Test {
    
    public static void main(String[] args) {
        if (args.length >= 4) {
            
            // setup the stub
            Person stub = null;
            try {
                
                // set the endpoint on the fly, to allow going through monitor
                String host = args[1];
                String port = args[2];
                String target =  "http://" + host + ":" + port +
                    "/axis/services/person";
                stub = (new PersonServiceLocator()).getperson();
                ((Stub)stub)._setProperty(Stub.ENDPOINT_ADDRESS_PROPERTY,
                    target);
                System.out.println("Connecting to service at " + target);
                
            } catch (javax.xml.rpc.ServiceException ex) {
                System.out.println(ex.getMessage());
            }
            
            // try the actual request
            try {
                
                PersonBean person = null;
                if (args[0].equals("get")) {
                    person = stub.getPerson(Integer.parseInt(args[3]));
                } else if (args[0].equals("find")) {
                    person = stub.findPerson(args[3], null, null);
                } else {
                    System.out.println
                        ("First argument must be 'get' or 'find'");
                    System.exit(0);
                }
                System.out.println("Found " + person.getFName()+ ' ' + 
                    person.getLName() + " born " + person.getBorn() +
                    " at index " + person.getIndex());
                
            } catch (NoPersonException ex) {
                System.out.println("Got NoPersonException:");
                System.out.println(ex.getAddedInfo());
            } catch (Exception ex) {
                System.out.println("Got " + ex.getClass().getName());
                System.out.println(ex.getMessage());
            }
            
        } else {
            System.out.println("Usage: Test # [host [port]]");
        }
    }
}
